﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace windows
{
    public class Persoon:IEditableObject
    {
        private String naam;
        private String bckp_naam;
        private int bckp_leeftijd;
        private bool inTransaction;

        public String Naam
        {
            get { return naam; }
            set { SetNaam(value); }
        }
        private int leeftijd;

        public int Leeftijd
        {
            get { return leeftijd; }
            set { SetLeeftijd(value); }
        }
        public Persoon() { ;}
        public Persoon(String naam, int leeftijd)
        {
            SetNaam(naam);
            SetLeeftijd(leeftijd);
        }
        private void SetLeeftijd(int leeftijd)
        {
            if (leeftijd < 0) throw new PersoonException("Leeftijd mag niet negatief zijn");
            this.leeftijd = leeftijd;
        }
        private void SetNaam(String naam)
        {
            if (naam == null || naam.Length == 0) throw new PersoonException("Naam mag niet leeg zijn");
            this.naam = naam;
        }

        #region IEditableObject Members

        public void BeginEdit()
        {
            if (!inTransaction)
            {
                bckp_leeftijd = leeftijd;
                bckp_naam = naam;
                inTransaction = true;
            }

        }

        public void CancelEdit()
        {
            if (inTransaction)
            {
                inTransaction = false;
                leeftijd = bckp_leeftijd;
                naam = bckp_naam;
            }
        }

        public void EndEdit()
        {
            if (inTransaction)
            {
                inTransaction = false;
            }
        }

        #endregion
    }
    [global::System.Serializable]
    public class PersoonException : Exception
    {
        public PersoonException() { }
        public PersoonException(string message) : base(message) { }
        public PersoonException(string message, Exception inner) : base(message, inner) { }
        protected PersoonException(
          System.Runtime.Serialization.SerializationInfo info,
          System.Runtime.Serialization.StreamingContext context)
            : base(info, context) { }
    }
}
